Add initial support for python bindings
[alexxy/gromacs.git] / admin / git-pre-commit
index 10f6ef9bf8f61a4970a56552d4797b869c4bb487..ea17bc9019fcd4c925c8c03da0a472180a1c62b0 100755 (executable)
@@ -3,9 +3,9 @@
 # This file is part of the GROMACS molecular simulation package.
 #
 # Copyright (c) 2013, by the GROMACS development team, led by
-# David van der Spoel, Berk Hess, Erik Lindahl, and including many
-# others, as listed in the AUTHORS file in the top-level source
-# directory and at http://www.gromacs.org.
+# Mark Abraham, David van der Spoel, Berk Hess, and Erik Lindahl,
+# and including many others, as listed in the AUTHORS file in the
+# top-level source directory and at http://www.gromacs.org.
 #
 # GROMACS is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public License
 # the research papers on the package. Check out http://www.gromacs.org.
 
 # This script is intended as a pre-commit hook that optionally runs all
-# changes through uncrustify.  By default, it does nothing.  To enable the
-# script after copying it to .git/hooks/pre-commit, you need to set
+# changes through some formatting check.  Currently, it runs uncrustify and
+# checks copyright headers.
+#
+# By default, it does nothing.  To enable the script after copying it to
+# .git/hooks/pre-commit, you need to set
 #   git config hooks.uncrustifymode check
 #   git config hooks.uncrustifypath /path/to/uncrustify
 # With this configuration, all source files modified in the commit are run
-# through uncrustify (see admin/uncrustify.sh for how this set of files is
-# determined).  If any file is changed by uncrustify, the names of those files
-# are reported and the commit is prevented.
+# through uncrustify and checked for correct copyright headers
+# (see admin/uncrustify.sh for how this set of files is determined).
+# If any file is changed by uncrustify or has other problems, the names of
+# those files are reported and the commit is prevented.  The issues can be
+# fixed by running admin/uncrustify.sh manually.
+#
 # To disable the hook, you can set
 #   git config hooks.uncrustifymode off
+# To disable it temporarily for a commit, set NO_FORMAT_CHECK environment
+# variable.  For example,
+#   NO_FORMAT_CHECK=1 git commit -a
+# You can also run git commit --no-verify, but that also disables other hooks,
+# such as the Change-Id hook used by gerrit.
 #
 # The actual work is done by the admin/uncrustify.sh script, which gets
 # run with the 'check-index' action.
 # See the comments in that script for more information.
 
+if [ ! -z "$NO_FORMAT_CHECK" ]
+then
+    exit 0
+fi
+
 if git rev-parse --verify HEAD >/dev/null 2>&1
 then
-       against=HEAD
+    against=HEAD
 else
-       # Initial commit: diff against an empty tree object
-       against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
+    # Initial commit: diff against an empty tree object
+    against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
 fi
 
 # Redirect output to stderr.
 exec 1>&2
 
 uncrustify_mode=`git config hooks.uncrustifymode`
+copyright_mode=`git config hooks.copyrightmode`
+if [ -z "$uncrustify_mode" ]
+then
+    uncrustify_mode=off
+fi
+if [ -z "$copyright_mode" ]
+then
+    copyright_mode=off
+fi
 
-if [ -f admin/uncrustify.sh ] && \
-   [ ! -z "$uncrustify_mode" ] && [ "$uncrustify_mode" != "off" ]
+if [[ -f admin/uncrustify.sh && \
+      ( "$uncrustify_mode" != "off" || "$copyright_mode" != "off" ) ]]
 then
-    uncrustify_path=`git config hooks.uncrustifypath`
-    if [ -z "$uncrustify_path" ]
+    if [ "$uncrustify_mode" != "off" ]
     then
-        echo "Please set the path to uncrustify using 'git config hooks.uncrustifypath'."
-        echo "Note that you need a custom version of uncrustify."
+        uncrustify_path=`git config hooks.uncrustifypath`
+        if [ -z "$uncrustify_path" ]
+        then
+            echo "Please set the path to uncrustify using 'git config hooks.uncrustifypath'."
+            echo "Note that you need a custom version of uncrustify."
+            exit 1
+        fi
+        export UNCRUSTIFY="$uncrustify_path"
+    fi
+    admin/uncrustify.sh check-index --rev=$against \
+        --uncrustify="$uncrustify_mode" --copyright="$copyright_mode"
+    stat=$?
+    if [ $stat -eq 1 ] ; then
+        exit 1
+    elif [ $stat -ne 0 ] ; then
+        echo "Source code formatting check failed"
         exit 1
     fi
-    export UNCRUSTIFY="$uncrustify_path"
-    case "$uncrustify_mode" in
-        check)
-            admin/uncrustify.sh check-index --rev=$against
-            stat=$?
-            if [ $stat -eq 1 ] ; then
-                exit 1
-            elif [ $stat -ne 0 ] ; then
-                echo "Source code formatting check failed"
-                exit 1
-            fi
-            ;;
-        *)
-            echo "Unknown uncrustify mode: $uncrustify_mode"
-            exit 1
-            ;;
-    esac
 fi